/* pm1.c */

#include <stdio.h>
#define INCL_WIN
#include <os2.h>
#include "pm1.h"

#pragma linkage (ClientWndProc, system)

static MRESULT ClientWndProc (HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
    {
    HPS hps;
    RECTL rcl;

    switch (msg)
        {
        case WM_PAINT:
            hps = WinBeginPaint (hwnd, NULL, NULL);
            /* (void)GpiErase (hps); */
            (void)WinQueryWindowRect (hwnd, &rcl);
            (void)GpiSetColor (hps, CLR_DARKCYAN);
            (void)WinDrawText (hps, -1, "Hello, world!", &rcl, 0, 0,
                       DT_TEXTATTRS | DT_CENTER | DT_VCENTER | DT_ERASERECT);
            (void)WinEndPaint (hps);
            return (0);
        case WM_COMMAND:
            switch (SHORT1FROMMP (mp1))
                {
                case IDM_EXIT:
                    (void)WinSendMsg (hwnd, WM_CLOSE, 0L, 0L);
                    return ((MRESULT)0);
                }
            break;
        }
    return (WinDefWindowProc (hwnd, msg, mp1, mp2));
    }


int main (void)
     {
     static ULONG flFrameFlags;
     static char szClientClass[] = "pm1.child";
     HAB hab;
     HMQ hmq;
     HWND hwndFrame;
     QMSG qmsg;

     hab = WinInitialize (0) ;
     hmq = WinCreateMsgQueue (hab, 0) ;

     (void)WinRegisterClass (hab, szClientClass, ClientWndProc,
                             CS_SIZEREDRAW, 0);

     flFrameFlags = FCF_TITLEBAR      | FCF_SYSMENU  |
                    FCF_SIZEBORDER    | FCF_MINMAX   |
                    FCF_MENU          | FCF_ACCELTABLE |
                    FCF_SHELLPOSITION | FCF_ICON |
                    FCF_TASKLIST;

     hwndFrame = WinCreateStdWindow (
                    HWND_DESKTOP,
                    WS_VISIBLE,
                    &flFrameFlags,
                    szClientClass,
                    NULL,
                    0L,
                    0,
                    ID_PM1,
                    NULL) ;

     while (WinGetMsg (hab, &qmsg, NULL, 0, 0))
          (void)WinDispatchMsg (hab, &qmsg);

     (void)WinDestroyWindow (hwndFrame);
     (void)WinDestroyMsgQueue (hmq);
     (void)WinTerminate (hab);
     return (0);
     }
